#include <ESPMegaPRO_OOP.hpp>

// Instantiate ESPMega
ESPMegaPRO espmega = ESPMegaPRO();

void mqtt_callback(char *topic, char *payload)
{
  Serial.print("MQTT Callback: ");
  Serial.print(topic);
  Serial.print(" ");
  Serial.println(payload);
}

void setup()
{
  // Initialize ESPMega
  espmega.begin();
  Serial.println("ESPMega initialized");
  espmega.enableIotModule();
  espmega.iot.connectToEthernet();
  IPAddress ip(192, 168, 0, 11);
  IPAddress gateway(192, 168, 0, 1);
  IPAddress subnet(255, 255, 255, 0);
  espmega.iot.setETHStaticIp(ip, gateway, subnet);
  espmega.iot.setBaseTopic("/testmegaoop");
  espmega.iot.connectToMqtt("espmega", "192.168.0.26", 1883);
  espmega.iot.publishRelative("test", "test");
  espmega.iot.subscribeRelative("test");
  espmega.iot.registerMqttCallback(mqtt_callback);
  Serial.println("ESPMega IoT initialized");
}

void loop()
{
    // Call ESPMega loop
    espmega.loop();
}